package jp.ac.takushoku_u.cs;

/**
* Vertexクラスはグラフの要素を保持するクラスです。<BR>
* @version 1.0.1
* @author 河原 慎治(Kawahara Shinji)
* @see VertexSet
*/
/*
* 最終更新日 2005年11月21日
*/
public class Vertex{
	
/**
* 要素番号
*/
	private int vertex;
	
	
/**
* 初期要素番号
*/
	private static final int INITIALIZE_VERTEX = 0;
	
/**
* デフォルトの要素で要素を設定します。
* 要素0で設定されます。
*/
	public Vertex(){
		setVertex(INITIALIZE_VERTEX);
	}
	
/**
* 要素を設定します。
* @param ver 要素
*/
	public Vertex(int ver){
		setVertex(ver);
	}
	
/**
* 要素を返します。
* @return 要素
*/
	public int getVertex(){
		return vertex;
	}
	
	public int getVertex(int ver){
		return ver;
	}
	public int getVertex(Vertex ver){
	return	ver.getVertex();
	}
	
	
/**
* 指定されたVertexは同じ要素を表しているかを比較します。
* @param ver 比較するVertex
* @return 同じ要素を表していれば true
*/
	public boolean isSameEdge(Vertex ver){
		return (getVertex() == getVertex(ver));
	}
	
/**
* 要素の設定をします。
* @param ver 要素
* @exception NegativeValueException 指定された要素番号が負である場合
*/
	private void setVertex(int ver){
		if(ver >= 0){
		vertex = ver;
		}
		else{
			throw new NegativeValueException("vertex("+vertex+")");
		}
	}	
/**
* 指定された値は負ではないかチェックします。
* @param value チェックする値
* @return 値が正または0であれば true
*/
	private boolean isPositive(int value){
		return value >= 0;
	}
}
